git-stash.sh 10.3 KB
Newer Older
しらいしななこ 已提交
1 2 3
#!/bin/sh
# Copyright (c) 2007, Nanako Shiraishi

4 5
dashless=$(basename "$0" | sed -e 's/-/ /')
USAGE="list [<options>]
S
Stephen Boyd 已提交
6 7 8
   or: $dashless show [<stash>]
   or: $dashless drop [-q|--quiet] [<stash>]
   or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9
   or: $dashless branch <branchname> [<stash>]
10
   or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet] [<message>]]
11
   or: $dashless clear"
しらいしななこ 已提交
12

13
SUBDIRECTORY_OK=Yes
14
OPTIONS_SPEC=
15
START_DIR=`pwd`
しらいしななこ 已提交
16 17
. git-sh-setup
require_work_tree
18
cd_to_toplevel
しらいしななこ 已提交
19 20

TMP="$GIT_DIR/.git-stash.$$"
21 22
TMPindex=${GIT_INDEX_FILE-"$GIT_DIR/index"}.stash.$$
trap 'rm -f "$TMP-"* "$TMPindex"' 0
しらいしななこ 已提交
23 24 25

ref_stash=refs/stash

T
Thomas Rast 已提交
26 27 28 29 30 31 32 33
if git config --get-colorbool color.interactive; then
       help_color="$(git config --get-color color.interactive.help 'red bold')"
       reset_color="$(git config --get-color '' reset)"
else
       help_color=
       reset_color=
fi

しらいしななこ 已提交
34
no_changes () {
35 36
	git diff-index --quiet --cached HEAD --ignore-submodules -- &&
	git diff-files --quiet --ignore-submodules
しらいしななこ 已提交
37 38 39
}

clear_stash () {
40 41 42 43
	if test $# != 0
	then
		die "git stash clear with parameters is unimplemented"
	fi
44
	if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
45
	then
E
Emil Medve 已提交
46
		git update-ref -d $ref_stash $current
47
	fi
しらいしななこ 已提交
48 49
}

J
Junio C Hamano 已提交
50
create_stash () {
51 52
	stash_msg="$1"

53
	git update-index -q --refresh
しらいしななこ 已提交
54 55 56 57
	if no_changes
	then
		exit 0
	fi
58

しらいしななこ 已提交
59
	# state of the base commit
60
	if b_commit=$(git rev-parse --verify HEAD)
しらいしななこ 已提交
61
	then
J
Jeff King 已提交
62
		head=$(git rev-list --oneline -n 1 HEAD --)
しらいしななこ 已提交
63 64 65 66
	else
		die "You do not have the initial commit yet"
	fi

67
	if branch=$(git symbolic-ref -q HEAD)
しらいしななこ 已提交
68 69 70 71 72 73 74 75
	then
		branch=${branch#refs/heads/}
	else
		branch='(no branch)'
	fi
	msg=$(printf '%s: %s' "$branch" "$head")

	# state of the index
76
	i_tree=$(git write-tree) &&
77
	i_commit=$(printf 'index on %s\n' "$msg" |
78
		git commit-tree $i_tree -p $b_commit) ||
しらいしななこ 已提交
79 80
		die "Cannot save the current index state"

T
Thomas Rast 已提交
81 82 83 84 85
	if test -z "$patch_mode"
	then

		# state of the working tree
		w_tree=$( (
86 87
			git read-tree --index-output="$TMPindex" -m $i_tree &&
			GIT_INDEX_FILE="$TMPindex" &&
T
Thomas Rast 已提交
88
			export GIT_INDEX_FILE &&
89
			git diff --name-only -z HEAD | git update-index -z --add --remove --stdin &&
T
Thomas Rast 已提交
90
			git write-tree &&
91
			rm -f "$TMPindex"
T
Thomas Rast 已提交
92 93 94 95 96
		) ) ||
			die "Cannot save the current worktree state"

	else

97
		rm -f "$TMP-index" &&
T
Thomas Rast 已提交
98 99 100 101 102 103 104 105
		GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&

		# find out what the user wants
		GIT_INDEX_FILE="$TMP-index" \
			git add--interactive --patch=stash -- &&

		# state of the working tree
		w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
しらいしななこ 已提交
106 107
		die "Cannot save the current worktree state"

T
Thomas Rast 已提交
108 109 110 111 112 113 114 115 116
		git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
		test -s "$TMP-patch" ||
		die "No changes selected"

		rm -f "$TMP-index" ||
		die "Cannot remove temporary index (can't happen)"

	fi

しらいしななこ 已提交
117
	# create the stash
118 119 120 121 122 123 124
	if test -z "$stash_msg"
	then
		stash_msg=$(printf 'WIP on %s' "$msg")
	else
		stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
	fi
	w_commit=$(printf '%s\n' "$stash_msg" |
125
		git commit-tree $w_tree -p $b_commit -p $i_commit) ||
しらいしななこ 已提交
126
		die "Cannot record working tree state"
J
Junio C Hamano 已提交
127
}
しらいしななこ 已提交
128

J
Junio C Hamano 已提交
129
save_stash () {
130
	keep_index=
T
Thomas Rast 已提交
131
	patch_mode=
S
Stephen Boyd 已提交
132 133 134
	while test $# != 0
	do
		case "$1" in
135
		-k|--keep-index)
S
Stephen Boyd 已提交
136 137
			keep_index=t
			;;
T
Thomas Rast 已提交
138 139 140 141 142
		--no-keep-index)
			keep_index=
			;;
		-p|--patch)
			patch_mode=t
S
Stephen Boyd 已提交
143 144 145 146 147
			keep_index=t
			;;
		-q|--quiet)
			GIT_QUIET=t
			;;
148 149 150 151 152 153
		--)
			shift
			break
			;;
		-*)
			echo "error: unknown option for 'stash save': $1"
154
			echo "       To provide a message, use git stash save -- '$1'"
155 156
			usage
			;;
S
Stephen Boyd 已提交
157 158 159 160
		*)
			break
			;;
		esac
161
		shift
S
Stephen Boyd 已提交
162
	done
163

164
	stash_msg="$*"
J
Junio C Hamano 已提交
165

166
	git update-index -q --refresh
J
Junio C Hamano 已提交
167 168
	if no_changes
	then
S
Stephen Boyd 已提交
169
		say 'No local changes to save'
J
Junio C Hamano 已提交
170 171 172 173 174 175
		exit 0
	fi
	test -f "$GIT_DIR/logs/$ref_stash" ||
		clear_stash || die "Cannot initialize stash"

	create_stash "$stash_msg"
E
Emil Medve 已提交
176 177 178

	# Make sure the reflog for stash is kept.
	: >>"$GIT_DIR/logs/$ref_stash"
しらいしななこ 已提交
179

180
	git update-ref -m "$stash_msg" $ref_stash $w_commit ||
しらいしななこ 已提交
181
		die "Cannot save the current status"
S
Stephen Boyd 已提交
182
	say Saved working directory and index state "$stash_msg"
183

T
Thomas Rast 已提交
184
	if test -z "$patch_mode"
185
	then
T
Thomas Rast 已提交
186 187 188 189 190 191 192 193 194 195 196 197 198 199
		git reset --hard ${GIT_QUIET:+-q}

		if test -n "$keep_index" && test -n $i_tree
		then
			git read-tree --reset -u $i_tree
		fi
	else
		git apply -R < "$TMP-patch" ||
		die "Cannot remove worktree changes"

		if test -z "$keep_index"
		then
			git reset
		fi
200
	fi
しらいしななこ 已提交
201 202
}

203
have_stash () {
204
	git rev-parse --verify $ref_stash >/dev/null 2>&1
205 206
}

しらいしななこ 已提交
207
list_stash () {
208
	have_stash || return 0
209
	git log --format="%gd: %gs" -g "$@" $ref_stash --
しらいしななこ 已提交
210 211 212
}

show_stash () {
213
	assert_stash_like "$@"
214

215
	git diff ${FLAGS:---stat} $b_commit $w_commit
しらいしななこ 已提交
216 217
}

218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269
#
# Parses the remaining options looking for flags and
# at most one revision defaulting to ${ref_stash}@{0}
# if none found.
#
# Derives related tree and commit objects from the
# revision, if one is found.
#
# stash records the work tree, and is a merge between the
# base commit (first parent) and the index tree (second parent).
#
#   REV is set to the symbolic version of the specified stash-like commit
#   IS_STASH_LIKE is non-blank if ${REV} looks like a stash
#   IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
#   s is set to the SHA1 of the stash commit
#   w_commit is set to the commit containing the working tree
#   b_commit is set to the base commit
#   i_commit is set to the commit containing the index tree
#   w_tree is set to the working tree
#   b_tree is set to the base tree
#   i_tree is set to the index tree
#
#   GIT_QUIET is set to t if -q is specified
#   INDEX_OPTION is set to --index if --index is specified.
#   FLAGS is set to the remaining flags
#
# dies if:
#   * too many revisions specified
#   * no revision is specified and there is no stash stack
#   * a revision is specified which cannot be resolve to a SHA1
#   * a non-existent stash reference is specified
#

parse_flags_and_rev()
{
	test "$PARSE_CACHE" = "$*" && return 0 # optimisation
	PARSE_CACHE="$*"

	IS_STASH_LIKE=
	IS_STASH_REF=
	INDEX_OPTION=
	s=
	w_commit=
	b_commit=
	i_commit=
	w_tree=
	b_tree=
	i_tree=

	REV=$(git rev-parse --no-flags --symbolic "$@" 2>/dev/null)

	FLAGS=
J
Jon Seymour 已提交
270
	for opt
271
	do
J
Jon Seymour 已提交
272 273 274 275
		case "$opt" in
			-q|--quiet)
				GIT_QUIET=-t
			;;
276 277 278
			--index)
				INDEX_OPTION=--index
			;;
J
Jon Seymour 已提交
279 280
			-*)
				FLAGS="${FLAGS}${FLAGS:+ }$opt"
281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313
			;;
		esac
	done

	set -- $REV

	case $# in
		0)
			have_stash || die "No stash found."
			set -- ${ref_stash}@{0}
		;;
		1)
			:
		;;
		*)
			die "Too many revisions specified: $REV"
		;;
	esac

	REV=$(git rev-parse --quiet --symbolic --verify $1 2>/dev/null) || die "$1 is not valid reference"

	i_commit=$(git rev-parse --quiet --verify $REV^2 2>/dev/null) &&
	set -- $(git rev-parse $REV $REV^1 $REV: $REV^1: $REV^2: 2>/dev/null) &&
	s=$1 &&
	w_commit=$1 &&
	b_commit=$2 &&
	w_tree=$3 &&
	b_tree=$4 &&
	i_tree=$5 &&
	IS_STASH_LIKE=t &&
	test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
	IS_STASH_REF=t

314 315 316 317 318 319 320 321 322
	if test "${REV}" != "${REV%{*\}}"
	then
		# maintainers: it would be better if git rev-parse indicated
		# this condition with a non-zero status code but as of 1.7.2.1 it
		# it did not. So, we use non-empty stderr output as a proxy for the
		# condition of interest.
		test -z "$(git rev-parse "$REV" 2>&1 >/dev/null)" || die "$REV does not exist in the stash log"
	fi

323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342
}

is_stash_like()
{
	parse_flags_and_rev "$@"
	test -n "$IS_STASH_LIKE"
}

assert_stash_like() {
	is_stash_like "$@" || die "'$*' is not a stash-like commit"
}

is_stash_ref() {
	is_stash_like "$@" && test -n "$IS_STASH_REF"
}

assert_stash_ref() {
	is_stash_ref "$@" || die "'$*' is not a stash reference"
}

しらいしななこ 已提交
343
apply_stash () {
S
Stephen Boyd 已提交
344

345
	assert_stash_like "$@"
しらいしななこ 已提交
346

347 348 349 350 351 352 353 354
	git update-index -q --refresh &&
	git diff-files --quiet --ignore-submodules ||
		die 'Cannot apply to a dirty working tree, please stage your changes'

	# current index state
	c_tree=$(git write-tree) ||
		die 'Cannot apply a stash in the middle of a merge'

J
Junio C Hamano 已提交
355
	unstashed_index_tree=
356
	if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
357
			test "$c_tree" != "$i_tree"
J
Junio C Hamano 已提交
358
	then
359
		git diff-tree --binary $s^2^..$s^2 | git apply --cached
360 361
		test $? -ne 0 &&
			die 'Conflicts in index. Try without --index.'
362
		unstashed_index_tree=$(git write-tree) ||
363 364
			die 'Could not save index tree'
		git reset
J
Junio C Hamano 已提交
365
	fi
366

しらいしななこ 已提交
367 368 369 370 371 372 373
	eval "
		GITHEAD_$w_tree='Stashed changes' &&
		GITHEAD_$c_tree='Updated upstream' &&
		GITHEAD_$b_tree='Version stash was based on' &&
		export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
	"

S
Stephen Boyd 已提交
374 375
	if test -n "$GIT_QUIET"
	then
376
		GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
S
Stephen Boyd 已提交
377
	fi
378
	if git merge-recursive $b_tree -- $c_tree $w_tree
しらいしななこ 已提交
379 380
	then
		# No conflict
J
Junio C Hamano 已提交
381 382 383
		if test -n "$unstashed_index_tree"
		then
			git read-tree "$unstashed_index_tree"
384 385
		else
			a="$TMP-added" &&
386
			git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
387 388 389 390
			git read-tree --reset $c_tree &&
			git update-index --add --stdin <"$a" ||
				die "Cannot unstage modified files"
			rm -f "$a"
J
Junio C Hamano 已提交
391
		fi
S
Stephen Boyd 已提交
392 393 394 395 396
		squelch=
		if test -n "$GIT_QUIET"
		then
			squelch='>/dev/null 2>&1'
		fi
397
		(cd "$START_DIR" && eval "git status $squelch") || :
しらいしななこ 已提交
398 399
	else
		# Merge conflict; keep the exit status from merge-recursive
400
		status=$?
401
		if test -n "$INDEX_OPTION"
J
Junio C Hamano 已提交
402 403 404
		then
			echo >&2 'Index was not unstashed.'
		fi
405
		exit $status
しらいしななこ 已提交
406 407 408
	fi
}

409 410 411 412 413 414 415
pop_stash() {
	assert_stash_ref "$@"

	apply_stash "$@" &&
	drop_stash "$@"
}

416
drop_stash () {
417
	assert_stash_ref "$@"
418

419 420
	git reflog delete --updateref --rewrite "${REV}" &&
		say "Dropped ${REV} ($s)" || die "${REV}: Could not drop stash entry"
421 422

	# clear_stash if we just dropped the last stash entry
423
	git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
424 425
}

426 427 428
apply_to_branch () {
	test -n "$1" || die 'No branch name specified'
	branch=$1
429
	shift 1
430

431 432 433 434
	set -- --index "$@"
	assert_stash_like "$@"

	git checkout -b $branch $REV^ &&
435 436 437
	apply_stash "$@" && {
		test -z "$IS_STASH_REF" || drop_stash "$@"
	}
438 439
}

440
PARSE_CACHE='--not-parsed'
441 442 443 444 445 446 447 448 449 450 451 452
# The default command is "save" if nothing but options are given
seen_non_option=
for opt
do
	case "$opt" in
	-*) ;;
	*) seen_non_option=t; break ;;
	esac
done

test -n "$seen_non_option" || set "save" "$@"

しらいしななこ 已提交
453 454
# Main command set
case "$1" in
455 456
list)
	shift
しらいしななこ 已提交
457 458 459 460 461 462
	list_stash "$@"
	;;
show)
	shift
	show_stash "$@"
	;;
463 464
save)
	shift
465
	save_stash "$@"
466
	;;
しらいしななこ 已提交
467 468 469 470 471
apply)
	shift
	apply_stash "$@"
	;;
clear)
472 473
	shift
	clear_stash "$@"
しらいしななこ 已提交
474
	;;
J
Junio C Hamano 已提交
475 476 477 478 479 480 481
create)
	if test $# -gt 0 && test "$1" = create
	then
		shift
	fi
	create_stash "$*" && echo "$w_commit"
	;;
482 483 484 485
drop)
	shift
	drop_stash "$@"
	;;
486 487
pop)
	shift
488
	pop_stash "$@"
489
	;;
490 491 492 493
branch)
	shift
	apply_to_branch "$@"
	;;
しらいしななこ 已提交
494
*)
495 496
	case $# in
	0)
497
		save_stash &&
S
Stephen Boyd 已提交
498
		say '(To restore them type "git stash apply")'
499 500
		;;
	*)
501
		usage
502
	esac
503
	;;
しらいしななこ 已提交
504
esac